angular.module("umbraco.directives").directive('umbFormsDateRangePicker', function (assetsService, userService) {
    return {
        restrict: 'A',
        scope: {
            userLocale: "@",
            onChange: "="
        },
        template: '<div class="umb-forms-date-range-picker daterange daterange--double"></div>',
        link: function (scope, element) {

            assetsService.load([
                "/App_Plugins/UmbracoForms/Assets/moment/min/moment-with-locales.min.js",
                "/App_Plugins/UmbracoForms/Assets/BaremetricsCalendar/public/js/calendar.js"
            ])
            .then(function () {

                //Set the moment locale to the current user's locale
                //Used for display, we still grab the date as YYYY-MM-DD to send to API endpoint
                moment.locale(scope.userLocale);

                var dd = new Calendar({
                    element: $(".daterange--double"),
                    earliest_date: 'January 1, 2000',
                    latest_date: moment(),
                    start_date: moment().subtract(29, 'days'),
                    end_date: moment(),
                    same_day_range: true,
                    callback: function () {

                        //Date update/changed

                        //Parse the dates from this component to Moment dates
                        var start = moment(this.start_date);
                        var end = moment(this.end_date);
                        var dateFilter = {};

                        dateFilter.startDate = start.format('YYYY-MM-DD');
                        dateFilter.endDate = end.format('YYYY-MM-DD');

                        if(scope.onChange) {
                            scope.onChange(dateFilter);
                        }

                    }
                });

            });

            //Load CSS as dependancy
            //load the seperate css for the editor to avoid it blocking our js loading
            assetsService.loadCss("/App_Plugins/UmbracoForms/Assets/BaremetricsCalendar/public/css/application.css");

        }
    };
});
