angular.module("umbraco.directives")
    .directive('umbFormsInlinePrevalueEditor', function (notificationsService) {
        return {
            restrict: 'E',
            replace: true,
            templateUrl: '/App_Plugins/UmbracoForms/directives/umb-forms-inline-prevalue-editor.html',
            require: "ngModel",
            link: function (scope, element, attr, ctrl) {
                scope.prevalues = [];

                ctrl.$render = function () {
                    if (Object.prototype.toString.call(ctrl.$viewValue) === '[object Array]') {
                        scope.prevalues = ctrl.$viewValue;
                    }
                };

                function updateModel() {
                    ctrl.$setViewValue(scope.prevalues);
                }

                function addPrevalue() {

                    //Check that our array does not already contain the same item
                    if (scope.prevalues.indexOf(scope.newPrevalue) < 0) {
                        scope.prevalues.push(scope.newPrevalue);
                        scope.newPrevalue = '';
                        updateModel();
                    } else {
                        //Notify user they are trying to add a prevalue that already exists
                        notificationsService.error("PreValue Error", "Unable to add PreValue as this is a duplicate");
                    }
                }

                scope.addPrevalue = function () {
                    addPrevalue();
                };

            }
        };
    });