angular.module('umbraco.filters').filter('truncate', function() {
    
    return function(input, noOfChars, appendDots) {
        
        //Check the length of the text we are filtering
        //If its greater than noOfChars param
        if(input.length > noOfChars){
            //Trim the text to the length of the param
            input = input.substr(0, noOfChars);
            
            //Only append the dots if we truncated
            //Append Dots is a bool
            if(appendDots){
                input = input + "...";
            }
        }
        
        return input;
    };
  
})
.filter('fileName', function() {
    
    return function(input) {
        
       // The input will be a path like so, we just want my-panda-photo.jpg
       // /media/forms/upload/f2ab8761-6a75-4c9d-a281-92e5e508856a/my-panda-photo.jpg
        
        input = input.split('\\').pop().split('/').pop();
        
        return input;
    };
  
});