﻿/**
    * @ngdoc service
    * @name umbraco.resources.dashboardResource
    * @description Handles loading the dashboard manifest
    **/
function formResource($http) {
    //the factory object returned
    var apiRoot = "backoffice/UmbracoForms/Form/";

    return {

        getScaffold: function (template) {
            return $http.get(apiRoot + "GetScaffold?template=" + template);
        },
        
        getScaffoldWithWorkflows: function (template) {
            return $http.get(apiRoot + "GetScaffoldWithWorkflows?template=" + template);
        },

        getAllTemplates: function () {
            return $http.get(apiRoot + "GetFormTemplates");
        },

        getOverView : function(){
                return $http.get(apiRoot + 'GetOverView');
        },

        getByGuid: function (id) {
            return $http.get(apiRoot + "GetByGuid?guid=" + id);
        },
        
        getWithWorkflowsByGuid: function (id) {
            return $http.get(apiRoot + "GetWithWorkflowsByGuid?guid=" + id);
        },

        deleteByGuid: function (id) {
            return $http.delete(apiRoot + "DeleteByGuid?guid=" + id);
        },

        save: function (form) {
            return $http.post(apiRoot + "PostSave", form);
        },
        
        saveWithWorkflows: function (formWithWorkflows) {
            return $http.post(apiRoot + "SaveForm", formWithWorkflows);
        },
        
        getAllFieldTypes: function() {
            return $http.get(apiRoot + "GetAllFieldTypes");
        },

        getAllFieldTypesWithSettings: function () {
            return $http.get(apiRoot + "GetAllFieldTypesWithSettings");
        },
        getPrevalueSources: function() {
            return $http.get(apiRoot + "GetPrevalueSources");
        },

        copy: function(id, newFormName) {
            return $http.post(apiRoot + "CopyForm", { guid: id, newName: newFormName });
        }
    };
}

angular.module('umbraco.resources').factory('formResource', formResource);
