﻿/**
    * @ngdoc service
    * @name umbraco.resources.formPickerResource
    * @description Used for picking Umbraco Forms with the Form Picker Property Editor
    **/
function formPickerResource($http, umbRequestHelper) {
    //the factory object returned

    //TODO: Use the same way way in core to register URLs in Global Umbraco.Sys.ServerVariables
    var apiRoot = "backoffice/UmbracoForms/FormPicker/";

    return {
       
        getFormsForPicker : function(formGuids){
            return umbRequestHelper.resourcePromise(
                $http.post(apiRoot + 'GetFormsForPicker', formGuids),
                "Failed to retrieve Forms to pick"
            );
        },

        getPickedForm: function (id) {
             return umbRequestHelper.resourcePromise(
                $http.get(apiRoot + "GetPickedForm?formGuid=" + id),
                "The picked/saved form with id '" + id + "' does not exist"
            );
        },

        getPickedForms: function (formGuids) {
             return umbRequestHelper.resourcePromise(
                $http.post(apiRoot + "GetPickedForms", formGuids),
                "The picked/saved form with id '" + formGuids + "' does not exist"
            );
        }
    };
}

angular.module('umbraco.resources').factory('formPickerResource', formPickerResource);
