/**
    * @ngdoc service
    * @name umbraco.resources.dashboardResource
    * @description Handles loading the dashboard manifest
    **/
function updatesResource($http) {
    //the factory object returned
    var apiRoot = "backoffice/UmbracoForms/Updates/";

    return {
        getUpdateStatus: function () {
            return $http.get(apiRoot + "GetUpdateStatus");
        },

        installLatest: function (version) {
            return $http.get(apiRoot + "InstallLatest?version=" + version);
        },

        getVersion: function() {
            return $http.get(apiRoot + "GetVersion");
        },

        getSavePlainTextPasswordsConfiguration: function() {
            return $http.get(apiRoot + "GetSavePlainTextPasswordsConfiguration");
        }
    };
}

angular.module('umbraco.resources').factory('updatesResource', updatesResource);
